#include"main.h"
/***************************************************************************
    "SVT" Phillip Blair's Spanish Vocabulary Tutor 
    Copyright (C) 1997  Phillip Vaughn Blair
    phillip_blair@writeme.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

**************************************************************************/
void view_database(void)
{
   datum key,nextkey,content;
   int i,ret_char;
   unsigned long current_record = 0;
   char cool = 1;
   char nouns_file_path[450];
   frame frame1;

   
   /* open the database for reading */
   strcpy(nouns_file_path,data_dir_name);
   strcat(nouns_file_path,"/nouns.spdbf");
   if((dbfvar = gdbm_open(nouns_file_path,510,
		      GDBM_READER,0644,0))==NULL)
     {
	move(17,10);
	addstr("could not open nouns database (to count them)");
	refresh();
	sleep(2);
	exit(EXIT_FAILURE);
     }
/*check number of records*/   
   if(!no_of_records)
     {
	key = gdbm_firstkey(dbfvar);
	if(key.dptr!=NULL)/* if there is a first  key, there's  probably a  next, */
	  {
	     for(i=0;i<100&&cool;i++)
	       {
		  no_of_records = no_of_records+1;
		  nextkey = gdbm_nextkey(dbfvar,key);
		  if(nextkey.dptr==NULL)
		    cool=0;
		  key = nextkey;
	       }
	  }
	else
	  no_of_records = 0;
	
     }/*okay,we now know how many existing entries (keys)...plus one...there are in the database,we can NOW add stuff after the end  of the database because we now have a numerical handle on that*/
   cool = 1;
/* main block of code for this function */
   do
     {
	key.dptr=(char*)&current_record;
	key.dsize = sizeof(current_record);
	content = gdbm_fetch(dbfvar,key);
	if(content.dptr == NULL)
	  {
	     move(17,10);
	     addstr("could not find a piece of data ");
	     move(18,10);
	     addstr("something's gone terribly wrong recently...");
	     refresh();
	     sleep(2);
	     exit(EXIT_FAILURE);
	  }
	
	frame1 = *((frame*)content.dptr);/*what the %^&*! is this? it works! kids don't try this at home!*/
	free(content.dptr);

	erase();
	refresh();
	move(9,10);
	addstr("current record:");
	printw("%lu",current_record);
	move(10,10);
	addstr("spanish:");
	addstr(frame1.spanish);
	move(11,10);
	addstr("english:");
	addstr(frame1.english);
	move(12,10);
	addstr("times right:");
	printw("%lu",frame1.right);
	addstr(" times wrong:");
	printw("%lu",frame1.wrong);
	move(13,10);
	addstr("last time accessed:");
	printw("%lu",frame1.ltiwa);
	refresh();
	/* this is the if 0 then only addstr press up arrow etc */
	if(current_record)
	  {
	     if(current_record == no_of_records - 1)
	       {
		  /* we're at the top so */
		  mvaddstr(14,10,"down arrow,or q key");
		  refresh();
		  ret_char = getch();
		  switch(ret_char)
		    {
		     case KEY_DOWN :
		       current_record--;
		       break;
		     case 'q':
		       cool = 0;
		       break;
		    }
	       }
	     else
	       {
		  /* else we're somewhere in the in-between between */
		  mvaddstr(14,10,"up or down arrow,or q key");
		  refresh();
		  ret_char = getch();
		  switch(ret_char)
		    {
		     case KEY_DOWN :
		       current_record--;
		       break;
		     case KEY_UP :
		       current_record++;
		       break;
		     case 'q':
		       cool = 0;
		       break;
		    }
	       }
	  }
	else
	  {
	     /* we're at zero,the bottom of the database,so.. */
	     mvaddstr(14,10,"up arrow,or q key");
	     refresh();
	     ret_char = getch();
	     switch(ret_char)
	       {
		case KEY_UP :
		  current_record++;
		  break;
		case 'q':
		  cool = 0;
		  break;
	       }
	  }
     }
   while(cool);
   
   gdbm_close(dbfvar);
   
}

void int_to_chars(unsigned long input,char *returns)
{
   div_t result;
   int index = 0;
   char index2 = 0;
   char temp[50];
   do
     {
	result = div(input,10);
	input = result.quot;
	temp[index] = result.rem + 48;
	index = index + 1;
     }while(input > 0);
   for(index = index;index >= 0;index--)
     {
	returns[index2] = temp[index - 1];/* index-1 patch i don't understand */
	index2 = index2 + 1;
     }
   returns[index2] = 0;
   return;
}
